"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _tapable = require("tapable");

var _pluginUtilities = require("@sewing-kit/plugin-utilities");

const PLUGIN = 'SewingKit.babel';
const addBabelHooks = (0, _pluginUtilities.addHooks)(() => ({
  babelConfig: new _tapable.AsyncSeriesWaterfallHook(['babelConfig']),
  babelIgnorePatterns: new _tapable.AsyncSeriesWaterfallHook(['babelIgnorePatterns'])
}));

var _default = (0, _pluginUtilities.createPlugin)({
  id: PLUGIN,
  target: _pluginUtilities.PluginTarget.Root
}, tasks => {
  tasks.build.tap(PLUGIN, ({
    hooks
  }) => {
    hooks.package.tap(PLUGIN, ({
      hooks
    }) => {
      hooks.configure.tap(PLUGIN, addBabelHooks);
    });
    hooks.webApp.tap(PLUGIN, ({
      hooks
    }) => {
      hooks.configure.tap(PLUGIN, addBabelHooks);
    });
    hooks.service.tap(PLUGIN, ({
      hooks
    }) => {
      hooks.configure.tap(PLUGIN, addBabelHooks);
    });
  });
  tasks.test.tap(PLUGIN, ({
    hooks
  }) => {
    hooks.project.tap(PLUGIN, ({
      hooks
    }) => {
      hooks.configure.tap(PLUGIN, addBabelHooks);
    });
  });
});

exports.default = _default;