import { AsyncSeriesWaterfallHook } from 'tapable';
import { addHooks, createPlugin, PluginTarget } from '@sewing-kit/plugin-utilities';
const PLUGIN = 'SewingKit.babel';
const addBabelHooks = addHooks(() => ({
  babelConfig: new AsyncSeriesWaterfallHook(['babelConfig']),
  babelIgnorePatterns: new AsyncSeriesWaterfallHook(['babelIgnorePatterns'])
}));
export default createPlugin({
  id: PLUGIN,
  target: PluginTarget.Root
}, tasks => {
  tasks.build.tap(PLUGIN, ({
    hooks
  }) => {
    hooks.package.tap(PLUGIN, ({
      hooks
    }) => {
      hooks.configure.tap(PLUGIN, addBabelHooks);
    });
    hooks.webApp.tap(PLUGIN, ({
      hooks
    }) => {
      hooks.configure.tap(PLUGIN, addBabelHooks);
    });
    hooks.service.tap(PLUGIN, ({
      hooks
    }) => {
      hooks.configure.tap(PLUGIN, addBabelHooks);
    });
  });
  tasks.test.tap(PLUGIN, ({
    hooks
  }) => {
    hooks.project.tap(PLUGIN, ({
      hooks
    }) => {
      hooks.configure.tap(PLUGIN, addBabelHooks);
    });
  });
});