"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tapable_1 = require("tapable");
const plugin_utilities_1 = require("@sewing-kit/plugin-utilities");
const PLUGIN = 'SewingKit.babel';
const addBabelHooks = plugin_utilities_1.addHooks(() => ({
    babelConfig: new tapable_1.AsyncSeriesWaterfallHook(['babelConfig']),
}));
exports.default = plugin_utilities_1.createPlugin({ id: PLUGIN, target: plugin_utilities_1.PluginTarget.Root }, (tasks) => {
    tasks.build.tap(PLUGIN, ({ hooks }) => {
        hooks.package.tap(PLUGIN, ({ hooks }) => {
            hooks.configure.tap(PLUGIN, addBabelHooks);
        });
        hooks.webApp.tap(PLUGIN, ({ hooks }) => {
            hooks.configure.tap(PLUGIN, addBabelHooks);
        });
        hooks.service.tap(PLUGIN, ({ hooks }) => {
            hooks.configure.tap(PLUGIN, addBabelHooks);
        });
    });
    tasks.test.tap(PLUGIN, ({ hooks }) => {
        hooks.project.tap(PLUGIN, ({ hooks }) => {
            hooks.configure.tap(PLUGIN, addBabelHooks);
        });
    });
});
